#include <iostream>
#include <fstream>
#include <string>
#include "CData.h"

using std::cout;
using std::cin;
using std::endl;

/* ========================================================================================== */
//  
// [in] filename -     
/* ========================================================================================== */
CData::CData(const char *filename){
	//      
	cFileName = new char[strlen(filename)];
	//       
	strncpy_s(cFileName, strlen(filename), filename, sizeof(filename));

	//     
	nFileSize = 0;
	nTotalElements = 0;
	nTotalPassedElements = 0;
	nMaxElement = 0;
	nMinElement = 0;
}

/* ========================================================================================== */
//  
/* ========================================================================================== */
CData::~CData(){
	//       
	if(cFileName)
		delete [] cFileName;
}

/* ========================================================================================== */
//    
// [in] nElementsToSave -   ( )
/* ========================================================================================== */
bool CData::bWriteDataToFile(UINT nElementsToSave){
	std::fstream outFile;
	//    
  outFile.open(cFileName, std::ios_base::out|std::ios_base::binary);
  
	//   
  if(outFile.is_open()){
		//      
    pFileDataArray = new int[nElementsToSave];
  
    UINT nCounter = 0;
		//     
		char iTmpData = 0;
		//     ,    
		cout << "=== Enter your elements: ===" << endl;
    while(nCounter < nElementsToSave) {
			cin >> iTmpData;
			//      
			if(isdigit(iTmpData)){
				//   -    
				pFileDataArray[nCounter] = atoi(&iTmpData);
				//    1
				++nCounter;
			}
			//  ,  
			else {
				cout << "You can enter only numeric character! Try again:" << endl;
			}
    }
		//      
    outFile.write((char*)pFileDataArray, (nElementsToSave * sizeof(int)));
		//  
    outFile.close();
		//       
    delete [] pFileDataArray;
		return true;
  }
	//     -  
  else {
    cout << "Can't open file " << cFileName << endl;
		return false;
	}
}

/* ========================================================================================== */
//    ,   
// [in] nMinDataElement -     
// [in] nMaxDataElement -     
/* ========================================================================================== */
int CData::iGetTotalPassedElements(int nMinDataElement, int nMaxDataElement){
	std::fstream inFile;
	//    
  inFile.open(cFileName, std::ios_base::in|std::ios_base::binary);
  
  //    
  if(inFile.is_open()){
    //        nFileSize
    inFile.seekg(0, inFile.end);
    nFileSize = inFile.tellg();
    inFile.seekg(0);

    //     
    //      /   
    //   
    nTotalElements = (nFileSize/sizeof(UINT));
		//        
    pFileDataArray = new int[nTotalElements];

		//     
    inFile.read((char*)pFileDataArray, nFileSize);
    inFile.close();

		//   ()      
		nMinElement = nMinDataElement;
		nMaxElement = nMaxDataElement;
    UINT nCounter = 0;
		//     
    while(nCounter < nTotalElements) {
			//   
      if(pFileDataArray[nCounter] < nMinElement || pFileDataArray[nCounter] > nMaxElement){
        //    - 
				//   
				++nCounter;
				//       
        ++nTotalPassedElements;
      }
      else
				//     - 
				//     
        ++nCounter;
    }
		//  
    delete [] pFileDataArray;
		//     
		return nTotalPassedElements;
  }
	//     -  
  else {
    cout << "Can't open file " << cFileName << endl;
		return 0;
	}
}

/* ========================================================================================== */
//     
// [in/out] DataArray - ,      
//  
/* ========================================================================================== */
bool CData::bFillArrayDataFromFile(int DataArray[]){
	std::fstream inFile;
	//    
  inFile.open(cFileName, std::ios_base::in|std::ios_base::binary);

	//    
  if(inFile.is_open()){
		//        
    pFileDataArray = new int[nTotalElements];

		//     
    inFile.read((char*)pFileDataArray, nFileSize);
    inFile.close();

    UINT nCounter = 0;
    UINT nElementsCounter = 0;
		//      
    while(nCounter < nTotalElements) {
			//   
      if(pFileDataArray[nCounter] < nMinElement || pFileDataArray[nCounter] > nMaxElement){
				//    - 
				//          
        DataArray[nElementsCounter] = pFileDataArray[nCounter];
				//   
        ++nCounter;
				//   ()     
        ++nElementsCounter;
      }
			//     - 
			//     
      else
        ++nCounter;
    }
		//  
    delete [] pFileDataArray;
		return true;
  }
  else {
    cout << "Can't open file " << cFileName << endl;
		return false;
	}
}